﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using Infragistics.Windows.DataPresenter;

namespace XamDataGridAddNew
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = CreateTable(3, 0).DefaultView;
        }

        public DataTable CreateTable(int columns, int rows)
        {
            DataTable d = new DataTable();

            for (int i = 0; i < columns; i++)
            {
                d.Columns.Add(new DataColumn("Column " + i, typeof(int)));
            }
            
            return d;
        }

        private void xamDataGrid1_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            if (e.OriginalSource is Path && (sender as XamDataGrid).RecordManager.CurrentAddRecord.IsActive)
            {
                (sender as XamDataGrid).RecordManager.CommitAddRecord();
            }
        }

        private void xamDataGrid1_RecordUpdating(object sender, Infragistics.Windows.DataPresenter.Events.RecordUpdatingEventArgs e)
        {
            if (e.Record.IsAddRecord && !(Mouse.DirectlyOver is Path) && !Keyboard.IsKeyDown(Key.Enter))
            {
                e.Action = RecordUpdatingAction.CancelUpdateRetainChanges;
            }
            if (Keyboard.IsKeyDown(Key.Enter))
            {
                // here you can determine whether to prevent or not the Enter key to add the Record
            }
        }
    }
}
